<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/css/bootstrap.min.css"
        integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js"
        integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.12.9/dist/umd/popper.min.js"
        integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/js/bootstrap.min.js"
        integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl"
        crossorigin="anonymous"></script>
    <script src="https://code.jquery.com/jquery-3.7.0.min.js"
        integrity="sha256-2Pmvv0kuTBOenSvLm6bvfBSSHrUJ+3A7x6P5Ebd07/g=" crossorigin="anonymous"></script>
    <title>Province from</title>
</head>

<body>
    <form action="province-form">
        <h3 class="text-center mt-5 mb-5">PROVINCE FORM</h3>
        <div class="jumbotron container">
            <div class="row form-group">
                <div class="col-4">
                    <label class="font-weight-bold text-right" for="">Tỉnh/ Thành phố:</label>
                </div>
                <div class="col-6">
                    <select class="form-control" name="province" id="province-select">
                        <option value="0">Tỉnh/ Thành phố</option>
                    </select>
                </div>
            </div>
            <div class="row form-group">
                <div class="col-4">
                    <label class="font-weight-bold text-right" for="">Quận/ Huyện:</label>
                </div>
                <div class="col-6">
                    <select class="form-control" name="district" id="district-select">
                        <option value="0">Quận/ Huyện</option>
                    </select>
                </div>
            </div>
            <div class="row form-group">
                <div class="col-4">
                    <label class="font-weight-bold text-right" for="">Phường/ Xã:</label>
                </div>
                <div class="col-6">
                    <select class="form-control" name="ward" id="ward-select">
                        <option value="0">Phường/ Xã</option>
                    </select>
                </div>
            </div>
        </div>
    </form>
</body>
<script>
    $(document).ready(function(){
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC, gọi hàm khi load */

    /*** Region 2: gán hàm xử lý sự kiện ***/
        onPageLoading();
        $("#province-select").change(function(){
            onProvinceSelectChanged(this);
        });
        $("#district-select").change(function(){
            onDistrictSelectChanged(this);
        });
    /*** Region 3: hàm xử lý sự kiện  */
        function onPageLoading(){
            $.ajax({
                url: "http://localhost:8080/provinces",
                type: "GET",
                dataType: "JSON",
                success: function(response){
                    // console.log(response);
                    handleProvinceSelect(response);
                },
                error: function(errorResponse){
                    alert(errorResponse);
                }
            });
        }
        function onProvinceSelectChanged(paramProvinceSelect) { 
            var provinceId = $(paramProvinceSelect).val();
            $.ajax({
                url: "http://localhost:8080/provinces/districts?provinceId=" + provinceId,
                type: "GET",
                dataType: "JSON",
                success: function(response){
                    // console.log(response);
                    handleDistrictSelect(response);
                },
                error: function(errorResponse){
                    alert(errorResponse);
                }
            });

        }
        function onDistrictSelectChanged(paramDistrictSelect) { 
            var districtId = $(paramDistrictSelect).val();
            $.ajax({
                url: "http://localhost:8080/provinces/districts/wards?districtId=" + districtId,
                type: "GET",
                dataType: "JSON",
                success: function(response){
                    // console.log(response);
                    handleWardSelect(response);
                },
                error: function(errorResponse){
                    alert(errorResponse);
                }
            });

        }
    /*** Region 4: hàm dùng chung*/

    function handleProvinceSelect(paramProvinces){
        var vProvinceSelect = $("#province-select");
        for(var bI = 0; bI< paramProvinces.length; bI++){
            $("<option>").val(paramProvinces[bI].id)
                .html(paramProvinces[bI].name)
                .appendTo(vProvinceSelect);
        }
    }
    function handleDistrictSelect(paramDistricts){
        var vDistrictSelect = $("#district-select");
        for(var bI = 0; bI< paramDistricts.length; bI++){
            $("<option>").val(paramDistricts[bI].id)
                .html(paramDistricts[bI].name)
                .appendTo(vDistrictSelect);
        }
    }
    function handleWardSelect(paramWards){
        var vWardSelect = $("#ward-select");
        for(var bI = 0; bI< paramWards.length; bI++){
            $("<option>").val(paramWards[bI].id)
                .html(paramWards[bI].name)
                .appendTo(vWardSelect);
        }
    }
    })
</script>

</html>